<?php

include_once '../sys/inc/start.php';
include_once '../sys/inc/update.php';
dpanel::check_access();
$doc = new document(groups::max());
$doc->title = __('Обновление системы');

if (!@function_exists('ignore_user_abort')) {
    $doc->err(__('функция ignore_user_abort не поддерживается данным сервером. Обновление невозможно.'));
    $doc->ret(__('Админка'), '/dpanel/');
    exit;
}

if (!@function_exists('set_time_limit')) {
    $doc->err(__('функция set_time_limit не поддерживается данным сервером. Обновление невозможно.'));
    $doc->ret(__('Админка'), '/dpanel/');
    exit;
}

if (!empty($_FILES ['file'])) {
    if ($_FILES ['file'] ['error']) {
        $doc->err(__('Ошибка при загрузке'));
    } elseif (!$_FILES ['file'] ['size']) {
        $doc->err(__('Содержимое файла пусто'));
    } else {
        dcms_update($_FILES ['file'] ['tmp_name']);
    }
}




$newversion = dcms_update_check_new_update();

if (isset($_POST['autoupdate'])) {
    if (dcms_update_auto()) {
        $doc->msg('Обновление успешно выполнено');
    } else {
        $doc->err('При обновлении возникли ошибки (см. лог)');
    }
}

if ($newversion) {
    if (version_compare($newversion, $dcms->version, '>')) {
        $doc->msg('Доступна новая весия DCMS: ' . $newversion);
        $smarty = new design ();
        $smarty->assign('method', 'post');
        $smarty->assign('action', '?update=' . urlencode($newversion) . '&amp;' . passgen());
        $elements = array();
        $elements [] = array('type' => 'submit', 'br' => 0, 'info' => array('name' => 'autoupdate', 'value' => __('Обновить автоматически'))); // кнопка
        $smarty->assign('el', $elements);
        $smarty->display('input.form.tpl');
    } else {
        $doc->msg('Вы используете последнюю версию DCMS: ' . $newversion);
    }
}

$smarty = new design ();
$smarty->assign('method', 'post');
$smarty->assign('files', 1);
$smarty->assign('action', '?' . passgen());
$elements = array();
$elements [] = array('type' => 'file', 'title' => __('Пакет обновления'), 'br' => 1, 'info' => array('name' => 'file'));
$elements [] = array('type' => 'submit', 'br' => 0, 'info' => array('value' => __('Обновить'))); // кнопка
$smarty->assign('el', $elements);
$smarty->display('input.form.tpl');

if (isset($_POST ['save'])) {
    // название сайта
    $dcms->update_auto = min(max($_POST ['update_auto'], 0), 2);

    if ($dcms->save_settings()) {
        $doc->msg(__('Настройки успешно сохранены'));
    } else {
        $doc->err(__('Нет прав на запись в файл настроек'));
    }
}




$form = new design();
$form->assign('method', 'post');
$form->assign('action', '?' . passgen());
$elements = array();
$options = array();
$options[] = array(0, __('Отключено'), $dcms->update_auto == 0);
$options[] = array(1, __('Уведомлять о новой версии'), $dcms->update_auto == 1);
$options[] = array(2, __('Устанавливать новую версию'), $dcms->update_auto == 2);
$elements[] = array('type' => 'select', 'title' => __('Автоматическое обновление'), 'br' => 1, 'info' => array('name' => 'update_auto', 'options' => $options));
$elements[] = array('type' => 'submit', 'br' => 0, 'info' => array('name' => 'save', 'value' => __('Применить'))); // кнопка
$form->assign('el', $elements);
$form->display('input.form.tpl');



$doc->ret(__('Админка'), '/dpanel/');
?>