<?php

list ( $msec, $sec ) = explode(chr(32), microtime()); // время запуска скрипта
define('TIME_START', $sec + $msec); // время запуска скрипта
define('DCMS', true);


if (!defined('IS_WINDOWS')) {
    if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
        define('IS_WINDOWS', true);
    } else {
        define('IS_WINDOWS', false);
    }
}

if (@function_exists('ini_set')) {
    ini_set('date.timezone', 'Europe/Moscow');
}

define('REQUIRE_PHP_VERSION', '5.2'); // запрашиваемая версия PHP


if (file_exists($_SERVER ['DOCUMENT_ROOT'] . '/sys/plugins/classes/dcms.class.php')) {
    define('H', $_SERVER ['DOCUMENT_ROOT']); // корневая директория сайта
} else {
    /* Если $_SERVER ['DOCUMENT_ROOT'] не является корневой директорией сайта, то будем искать ее вручную */

    $rel_path = '';
    $searched_file = 'sys/plugins/classes/dcms.class.php';
    for ($i = 0; $i < 10; $i++) {
        if (file_exists($rel_path . $searched_file)) {
            $abs_path = realpath($rel_path . $searched_file);
            break;
        }
        $rel_path .= '../';
    }
    define('H', str_replace($searched_file, '', str_replace('\\', '/', $abs_path))); // корневая директория сайта
    unset($rel_path, $searched_file, $abs_path);
}

// Временные папки
define('TEMP', H . '/sys/tmp');
define('TMP', H . '/sys/tmp');

// папка со всеми пользовательскими файлами
define('FILES', realpath(H . '/sys/files'));

// временная метка unix
define('TIME', time());

// временная метка на начало текущих суток
define('DAY_TIME', mktime(0, 0, 0));

// главная страница
define('IS_MAIN', $_SERVER ['SCRIPT_NAME'] == '/index.php');

// время жизни сессии, а также время последней активности пользователей, считающихся онлайн
define('SESSION_LIFE_TIME', 600);

// имя сессии
define('SESSION_NAME', 'DCMS_SESSION');

// ключ сессий, в котором хранится идентификатор пользователя
define('SESSION_ID_USER', 'DCMS_SESSION_ID_USER');

// идентификатор пользователя в COOKIE
define('COOKIE_ID_USER', 'DCMS_COOKIE_ID_USER');

// пароль пользователя в COOKIE
define('COOKIE_USER_PASSWORD', 'DCMS_COOKIE_USER_PASSWORD');


if (@function_exists('ini_set')) {

    // время жизни сессии
    ini_set('session.cache_expire', SESSION_LIFE_TIME);

    // игнорировать повторяющиеся ошибки
    ini_set('ignore_repeated_errors', true);

    // показываем только фатальные ошибки
    ini_set('error_reporting', E_ERROR);

    // непосредственно, включаем показ ошибок
    ini_set('display_errors', true);
}


// текущая страница
define('URL', urlencode($_SERVER ['REQUEST_URI']));


if (function_exists('mb_internal_encoding')) {
    // Выставляем кодировку для mb_string  
    mb_internal_encoding('UTF-8');
}


if (function_exists('iconv')) {
    // Выставляем кодировку для Iconv
    iconv_set_encoding('internal_encoding', 'UTF-8');
}

// Проверяем версию PHP
version_compare(phpversion(), REQUIRE_PHP_VERSION, '>=') or die('Требуется PHP >= ' . REQUIRE_PHP_VERSION);

// функция автоматической загрузки классов
function dcmsAutoload($class_name) {
    $path = H . '/sys/plugins/classes/' . strtolower($class_name) . '.class.php';
    if (file_exists($path)) {
        include_once ($path);
    }
}

// регистрируем функцию для автоматической загрузки классов
spl_autoload_register('dcmsAutoload');


// во время автоматического обновления не должно быть запросов состороны пользователя
if (cache::get('system.update.work')) {
    exit('Выполняется обновление системы. Пожалуйста, обновите страницу позже.');
}

// генератор пароля
function passgen($len = 32) {
    $password = '';
    $small = 'abcdefghijklmnopqrstuvwxyz';
    $large = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $numbers = '1234567890';
    // $symbols='_)(%^*!-';
    for ($i = 0; $i < $len; $i++) {
        switch (mt_rand(1, 3)) {
            // case 4:$password.=$symbols[mt_rand(0,8)];break;
            case 3 :
                $password .= $large [mt_rand(0, 25)];
                break;
            case 2 :
                $password .= $small [mt_rand(0, 25)];
                break;
            case 1 :
                $password .= $numbers [mt_rand(0, 9)];
                break;
        }
    }
    return $password;
}

/* Переназначение функций */

// упрощенный вариант mysql_real_escape_string
function my_esc($str) {
    return mysql_real_escape_string($str);
}

// фильтрование текста для полей ввода
function for_value($text) {
    return text::for_value($text);
}

// фильтрование и форматирование текста
function output_text($text) {
    return text::output_text($text);
}

// получение названия месяца
function rus_mes($mes, $v = 1) {
    return misc::rus_mes($mes, $v);
}

// получение читабельного представления времени
function vremja($t) {
    return misc::vremja($t);
}

// размер данных в байтах, килобайтах, мегабайтах...
function size_data($filesize = 0) {
    return misc::size_data($filesize);
}

// запись массива в ini файл 
function ini_file_write($path, $array) {
    return ini::save($path, $array);
}

/* ---------------------- */

/* Инициализация механизма сессий  */
session_name(SESSION_NAME) or die('Невозможно инициализировать сессии');
@session_start() or die('Невозможно инициализировать сессии');
define('SESS', preg_replace('#[^a-z0-9]#i', '', session_id()));
/* ------------------------------- */

// для совместимости
class cache_old {

    function get($key) {
        return cache::get($key);
    }

    function set($key, $data, $ttl = false) {
        return cache::set($key, $data, $ttl);
    }

}

$cache = new cache_old ();


// загрузка основного класса с настройками
$dcms = new dcms ();



// бан по IP  (инициализация)
$ban_by_ip = new ban_by_ip ();

// бан по IP
if ($msg = $ban_by_ip->is_ban($dcms->ip_long)) {
    exit('Ваш IP адрес заблокирован. Причина: ' . $msg);
}

// Anti-DoS (не путать с DDoS) - Защита от большого кол-ва запросов с одного IP адреса
if ($dcms->antidos) {

    $antidos_log = (array) cache::get('antidos.' . $dcms->ip_long);
    // удаление устаревших переходов
    foreach ($antidos_log as $id => $log) {
        if ($log['time'] < TIME - $dcms->antidos_period) {
            unset($antidos_log[$id]);
        }
    }
    $antidos_log[] = array('time' => TIME);
    cache::set('antidos.' . $dcms->ip_long, $antidos_log, $dcms->antidos_period);
    $count_for_period = count($antidos_log);
    $count_per_seconds = intval($count_for_period / $dcms->antidos_period);

    if ($count_per_seconds > $dcms->antidos_visits_per_second_for_ban) {
        $ban_by_ip->addIpLong($dcms->ip_long, 'Превышение разрешенного кол-ва обращений к сайту (antidos)', $dcms->antidos_period * 10);
        exit('Превышение разрешенного кол-ва обращений к сайту (antidos). Ваш IP забанен');
    }

    if ($count_per_seconds > $dcms->antidos_max_visits_per_second) {
        exit('Превышение разрешенного кол-ва обращений к сайту (antidos). Зайдите на сайт через ' . $dcms->antidos_period . ' сек');
    }
}


// этот параметр будут влиять на счетчики
if ($dcms->new_time_as_date) {
    // новые файлы, темы и т.д. будут отображаться только за текущее число
    define('NEW_TIME', DAY_TIME);
} else {
    // новые файлы, темы и т.д. будут отображаться только за последние 24 часа
    define('NEW_TIME', TIME - 86400);
}


@mysql_connect($dcms->mysql_host, $dcms->mysql_user, $dcms->mysql_pass) or die('Нет соединения с сервером базы');
@mysql_select_db($dcms->mysql_base) or die('Нет доступа к выбранной базе данных');
mysql_query('SET NAMES "utf8"');

// отправка писем из очереди
mail::queue_process();

// запись рефералов
if ($dcms->log_of_referers) {
    $log_of_referers = new log_of_referers ();
}
// запись посещений
if ($dcms->log_of_visits) {
    $log_of_visits = new log_of_visits ();

    // подведение итогов (хоть раз в сутки, чтобы не забивалась таблица)
    if (!cache::get('log_of_visits')) {
        $cache_time = mt_rand(82800, 86400); // переменное время хранения кэша (от 23 до 24 часов)
        $log_of_visits->tally(); // подведение итогов (хоть раз в сутки, чтобы не забивалась таблица)
        cache::set('log_of_visits', true, $cache_time);
    }
}


// Автоматическое обновление системы
if ($dcms->update_auto && !cache::get('system.update.auto')) {
    $cache_time = mt_rand(82800, 86400); // переменное время хранения кэша (от 23 до 24 часов)



    cache::set('system.update.auto', true, $cache_time);



    include H . '/sys/inc/update.php';
    $newversion = dcms_update_check_new_update();
    if (version_compare($newversion, $dcms->version, '>')) {

        if ($dcms->update_auto == 2 && @function_exists('ignore_user_abort') && @function_exists('set_time_limit')) {
            if (dcms_update_auto()) {
                // новая версия установлена
                $mess = __('Обновление DCMS (с %s по %s) успешно выполнено', $dcms->version, $newversion);
            } else {
                // при установке новой версии возникла ошибка
                $mess = __('При обновлении DCMS (с %s по %s) произошла ошибка', $dcms->version, $newversion);
            }
        } else {
            $mess = __('Вышла новая версия DCMS: %s. [url=/dpanel/sys.update.php]Обновить[/url]', $newversion);
        }

        $admins = groups::getAdmins();
        foreach ($admins AS $admin) {
            $admin->mess($mess);
        }
    }
}



// очистка от пользователей, которые не подтвердили регистрацию в течении суток.
if ($dcms->clear_users_not_verify && !cache::get('clear_users_not_verify')) {
    $cache_time = mt_rand(82800, 86400); // переменное время хранения кэша (от 23 до 24 часов)
    cache::set('clear_users_not_verify', true, $cache_time);


    $q = mysql_query("SELECT `id` FROM `users` WHERE `a_code` <> '' AND `reg_date` < '" . (TIME - 86400) . "'");
    if (mysql_num_rows($q)) {
        while ($u = mysql_fetch_assoc($q)) {
            misc::user_delete($u['id']);
        }
    }
}


// очистка от устаревших временных файлов (чтобы не забивалась папка sys/tmp)
if ($dcms->clear_tmp_dir && !cache::get('clear_tmp_dir')) {
    $cache_time = mt_rand(3500, 3600); // переменное время хранения кэша
    cache::set('clear_tmp_dir', true, $cache_time);
    $old_files = filesystem::getOldTmpFiles();
    foreach ($old_files as $path) {
        @unlink($path);
    }
}



// авторизация пользователя
if (!empty($_SESSION [SESSION_ID_USER])) {
    // авторизация по сессии
    $user = new user($_SESSION [SESSION_ID_USER]);
} elseif (!empty($_COOKIE [COOKIE_ID_USER]) && !empty($_COOKIE [COOKIE_USER_PASSWORD]) && $_SERVER ['SCRIPT_NAME'] !== '/login.php' && $_SERVER ['SCRIPT_NAME'] !== '/captcha.php') {
    // авторизация по COOKIE (получение сессии, по которой пользователь авторизуется)
    $user = new user(false);
    header('Location: /login.php?return=' . URL);
    exit;
} else {
    // пользователь будет являться гостем
    $user = new user(false);
}

// удаляем сессию пользователя, если по ней не удалось авторизоваться
if ($user->id === false && isset($_SESSION [SESSION_ID_USER])) {
    unset($_SESSION [SESSION_ID_USER]);
}

// удаление пользователей, вышедших из онлайна
mysql_query("DELETE FROM `users_online` WHERE `time_last` < '" . (TIME - SESSION_LIFE_TIME) . "'");
// обработка данных пользователя
if ($user->id !== false) {
    $user->last_visit = TIME; // запись последнего посещения
    $user->conversions++; // счетчик посещений
    $q = mysql_query("SELECT * FROM `users_online` WHERE `id_user` = '{$user->id}' LIMIT 1");
    if (mysql_num_rows($q)) {
        mysql_query("UPDATE `users_online` SET `conversions` = `conversions` + '1' , `time_last` = '" . TIME . "', `id_browser` = '$dcms->browser_id', `ip_long` = '$dcms->ip_long', `request` = '" . my_esc($_SERVER ['REQUEST_URI']) . "' WHERE `id_user` = '$user->id' LIMIT 1");
    } else {
        mysql_query("INSERT INTO `users_online` (`id_user`, `time_last`, `time_login`, `request`, `id_browser`, `ip_long`) VALUES ('$user->id', '" . TIME . "', '" . TIME . "', '" . my_esc($_SERVER ['REQUEST_URI']) . "', '$dcms->browser_id', '$dcms->ip_long')");
        $user->count_visit++;
    }
} else {
    // обработка гостя
    // зачистка гостей, вышедших из онлайна
    mysql_query("DELETE FROM `guest_online` WHERE `time_last` < '" . (TIME - SESSION_LIFE_TIME) . "'");

    $q = mysql_query("SELECT * FROM `guest_online` WHERE `ip_long` = '{$dcms->ip_long}' AND `browser` = '" . my_esc($dcms->browser) . "' LIMIT 1");
    if (mysql_num_rows($q)) {
        // повторные переходы гостя
        mysql_query("UPDATE `guest_online` SET `time_last` = '" . TIME . "', `request` = '" . my_esc($_SERVER ['REQUEST_URI']) . "', `conversions` = `conversions` + 1 WHERE  `ip_long` = '{$dcms->ip_long}' AND `browser` = '{$dcms->browser}' LIMIT 1");
    } else {
        // новый гость
        mysql_query("INSERT INTO `guest_online` (`ip_long`, `browser`, `time_last`, `time_start`, `request` ) VALUES ('{$dcms->ip_long}', '" . my_esc($dcms->browser) . "', '" . TIME . "', '" . TIME . "', '" . my_esc($_SERVER ['REQUEST_URI']) . "')");
    }
}

if ($user->is_ban_full && $_SERVER ['SCRIPT_NAME'] != '/ban.php') {
    // при полном бане никуда кроме страницы бана нельзя
    header('Location: /ban.php?' . SID);
    exit;
}


// включаем полный показ ошибок для создателя, если включено в админке
if ($dcms->display_errors && $user->group == groups::max() && @function_exists('ini_set')) {
    ini_set('error_reporting', E_ALL);
    ini_set('display_errors', true);
}




if ($user->language) {
    $lang = $user->language;
} elseif (!empty($_SESSION['language'])) {
    $lang = $_SESSION['language'];
} elseif ($dcms->language) {
    $lang = $dcms->language;
} else {
    $lang = 'default';
}


$dcms_language_pack = new language_pack($lang);

function __() {
    global $dcms_language_pack;

    $args = func_get_args();
    $args_num = func_num_args();
    if (!$args_num) {
        // нет ни строки ни параметров, вообще нихрена
        return '';
    }


    $string = $dcms_language_pack->getString($args[0]);

    if ($args_num == 1) {
        // строка без параметров
        return $string;
    }

// строка с параметрами
    $args4eval = array();
    for ($i = 1; $i < $args_num; $i++) {
        $args4eval[] = '$args[' . $i . ']';
    }
    return eval('return sprintf($string,' . implode(',', $args4eval) . ');');
}

?>