<?php

abstract class cache {

    static public function get($key) {
        $path = self::path($key);
        // чтение данных из файла
        if (!$content = @file_get_contents($path))
            return false;
        // разбор данных
        if (!$data = @unserialize($content)) {
            return false;
        }
        // проверка актуальности данных
        if ($data ['a'] < TIME) {
            @unlink($path);
            return false;
        }

        return $data ['d'];
    }

    static public function set($key, $data, $ttl = false) {
        $path = self::path($key);

        // удаленный кэш все равно вернет false, поэтому в целях незахламления папки tmp лучше файл удалить
        if ($data === false && $ttl === false) {
            return @unlink($path);
        }

        $data2 ['d'] = $data;
        $data2 ['a'] = TIME + $ttl;

        @file_put_contents($path, serialize($data2)) OR die('Ошибка записи кэша');
    }

    // получение пути к файлу кэша по ключу
    static private function path($key) {
        return TEMP . '/' . urlencode($key) . '.cache';
    }

}

?>
